<?php
/**
* @version $Id: zoomgallery.searchbot.php,v 1.0 2005/03/10 03:48:00 $
* @package Mambo_4.5.2
* @copyright (C) 2000 - 2004 Miro International Pty Ltd
* @copyright (C) 2004 - 2005 MamboHacks.com
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
* Mambo is Free Software
*/

/** ensure this file is being included by a parent file */
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

$_MAMBOTS->registerFunction( 'onSearch', 'botSearchZoom' );

/**
* Search method
*
* The sql must return the following fields that are used in a common display
* routine: href, title, section, created, text, browsernav
* @param string Target search string
* @param integer The state to search for -1=archived, 0=unpublished, 1=published [default]
* @param string A prefix for the section label, eg, 'Archived '
*/
function botSearchZoom( $text, $phrase='', $ordering='' ) {
	global $my, $database;
	global $mosConfig_abolute_path, $mosConfig_lang, $mosConfig_offset, $Itemid;
	$_SESSION['searchword'] = $text;

	$database->setQuery( "SELECT zoom_title FROM #__zoom_config" );
	$zoom_title =  $database->loadResult();

	$text = trim( $text );
	if ($text == '') {
		return array();
	}

	$wheres = array();
	$wherescat = array();
	switch ($phrase) {
		case 'exact':
			//Search Zoom Images
			$wheres2 = array();
			$wheres2[] = "LOWER(i.imgname) LIKE '%$text%'";
			$wheres2[] = "LOWER(i.imgfilename) LIKE '%$text%'";
			$wheres2[] = "LOWER(i.imgdescr) LIKE '%$text%'";
			$wheres2[] = "LOWER(i.imgkeywords) LIKE '%$text%'";
			$where = '(' . implode( ') OR (', $wheres2 ) . ')';

			//Search Zoom Categories
			$wherescat2 = array();
			$wherescat2[] = "LOWER(c.catname) LIKE '%$text%'";
			$wherescat2[] = "LOWER(c.catdescr) LIKE '%$text%'";
			$wherescat2[] = "LOWER(c.catkeywords) LIKE '%$text%'";
			$wherecat = '(' . implode( ') OR (', $wherescat2 ) . ')';
			break;
		case 'all':
		case 'any':
		default:
			$words = explode( ' ', $text );
			$wheres = array();
			foreach ($words as $word) {
				//Search Zoom images
				$wheres2 = array();
				$wheres2[] = "LOWER(i.imgname) LIKE '%$word%'";
				$wheres2[] = "LOWER(i.imgfilename) LIKE '%$word%'";
				$wheres2[] = "LOWER(i.imgdescr) LIKE '%$word%'";
				$wheres2[] = "LOWER(i.imgkeywords) LIKE '%$word%'";
				$wheres[] = implode( ' OR ', $wheres2 );

				//Search Zoom categories
				$wheres2 = array();
				$wherescat2[] = "LOWER(c.catname) LIKE '%$word%'";
				$wherescat2[] = "LOWER(c.catname) LIKE '%$word%'";
				$wherescat2[] = "LOWER(c.catname) LIKE '%$word%'";
				$wherescat[] = implode( ' OR ', $wherescat2 );
			}
			$where = '(' . implode( ($phrase == 'all' ? ') AND (' : ') OR ('), $wheres ) . ')';
			$wherecat = '(' . implode( ($phrase == 'all' ? ') AND (' : ') OR ('), $wherescat ) . ')';
			break;
	}

	switch ($ordering) {
		case 'newest':
		default:
			$order = 'i.imgdate DESC';
			$ordercat = 'c.catid DESC';
			break;
		case 'oldest':
			$order = 'i.imgdate ASC';
			$ordercat = 'c.catid ASC';
			break;
		case 'popular':
			$order = 'i.imghits DESC';
			//Need to change next line to sum hits of images in category.
			$ordercat = 'c.catid DESC';
			break;
		case 'alpha':
			$order = 'i.imgname ASC';
			$ordercat = 'c.catname ASC';
			break;
		case 'category':
			$order = 'c.catname ASC, i.imgname ASC';
			$ordercat = 'c.catname ASC';
			break;
	}

	$database->setQuery( "SELECT CONCAT_WS(' - ', i.imgname, i.imgfilename) AS title, "
	. "\n i.imgdate as created, "
	. "\n i.imgdescr as text, "
	. "\n CONCAT_WS(':', '$zoom_title', c.catname) as section, "
	. "\n CONCAT('temp') AS href, "
	. "\n '2' AS browsernav, "
	. "\n i.imgid AS imgid, i.imgfilename as imgfilename, c.catid as catid, c.catdir as catdir "
	. "\n FROM #__zoomfiles as i "
	. "\n LEFT JOIN #__zoom AS c ON i.catid = c.catid "
	. "\n WHERE ( $where )"
	. "\n AND i.published = '1' "
	. "\n ORDER BY $order"
	);

	$list = $database->loadObjectList();

	global $mosConfig_absolute_path;
	include_once($mosConfig_absolute_path."/components/com_zoom/zoom_config.php");
	require_once($mosConfig_absolute_path.'/components/com_zoom/classes/zoom.class.php');
	require_once($mosConfig_absolute_path.'/components/com_zoom/classes/editmon.class.php');

	$zoom = new zoom();
	if($zoom->isWin()){
		include_once($mosConfig_absolute_path."/components/com_zoom/classes/fs_win32.php");
	}else{
		include_once($mosConfig_absolute_path."/components/com_zoom/classes/fs_unix.php");
	}

	//Add image tags for the thumbnails.
	$Itemid = getItemid("com_zoom");
	foreach ($list as $i => $row) {
		$thumbfilename = "/".$zoomConfig['imagepath'].$list[$i]->catdir."/thumbs/".$list[$i]->imgfilename;
		//get video thumbnail
		$tmp1 = explode(".", $thumbfilename);
		$thumbfilename = $tmp1[0] . ".jpg";
		if (fs_file_exists($mosConfig_absolute_path.$thumbfilename)) {
			$imagetag = "<img src=\"" . $mosConfig_live_site . $thumbfilename."\" class=\"zoomsearchbotthumbnail\"><br>";
		} else {
			$imagetag =  $zoom->_CONFIG['imagepath'];
		}
		$list[$i]->title = $imagetag . $list[$i]->title;
		$list[$i]->href = getImageHref($list[$i]->imgid, $list[$i]->catid, $Itemid);

	}

	$database->setQuery( "SELECT c.catname AS title, "
	. "\n 'N/A' as created, "
	. "\n c.catdescr as text, "
	. "\n '$zoom_title' as section, "
	. "\n CONCAT('index.php?option=com_zoom&Itemid=',$Itemid,'&catid=', c.catid) AS href, "
	. "\n '2' AS browsernav "
	. "\n FROM #__zoom AS c "
	. "\n WHERE ( $wherecat )"
	. "\n AND c.published = '1' "
	. "\n ORDER BY $ordercat"
	);

	$list2 = $database->loadObjectList();

	return array_merge( $list2, $list);
}

function addArray(&$array, $id, $var)
{
   $tempArray = array( $var => $id);
   $array = array_merge ($array, $tempArray);
}

function getImageHref($imgid, $catid, $Itemid) {

	if (($imgid=='')or($catid=='')) {
		return "missing required values: imageid=$imgid, categorid=$catid";
    };

	global $mosConfig_absolute_path, $database;

	include($mosConfig_absolute_path.'/configuration.php');
	include($mosConfig_absolute_path.'/components/com_zoom/zoom_config.php');

	$BaseImagePath = ($mosConfig_live_site."/".$zoomConfig['imagepath']);

	$order			= $zoomConfig['orderMethod'];
	$zoomModule		= $zoomConfig['zoomModule'];
	$maxpagesize	= $zoomConfig['PageSize'];
	$order			= $zoomConfig['orderMethod']; //how zoom gallery orders when displaying
	$usepopup		= $zoomConfig['popUpImages'];

	// Create a string for querying later on
	if ($order == 1){ $myorder = 'imgdate ASC'; } //ok
	if ($order == 2){ $myorder = 'imgdate DESC'; } //ok
	if ($order == 3){ $myorder = 'imgfilename ASC'; } //ok
	if ($order == 4){ $myorder = 'imgfilename DESC'; } //ok
	if ($order == 5){ $myorder = 'imgname ASC'; } //ok
	if ($order == 6){ $myorder = 'imgname DESC'; } //ok

	//parameters passed to me are the category-id and the image-id
	$query="SELECT imgid FROM #__zoomfiles WHERE catid=$catid AND published=1 ORDER BY $myorder";
	//this will give use all published media in the order in which they are visible in gallery
	//so find the number of pages before the image becomes visible in gallery: this gives us pageno (use for non-popup modus only)

	$database->setQuery($query);
	$result = $database->query();

	//key-1 means no valid key;
	$i=0;
	$pageno=1; //zoom starts at page=1
	$keyno=-1; //-1 means no key found; zoom starts at key=0
	while (($keyno == -1) AND ($row = mysql_fetch_object($result))) {
		//echo "<h3>63 :: imgid=$imgid, page=$pageno, keyno=$keyno, i=$i, imgid=$row->imgid</h3>";
		if($imgid==$row->imgid){
			$keyno = $i;
		};

		if ($i>=$maxpagesize) {
			$pageno++; //increase pageno
			//$i=0; //resets possible key counter
		};

		$i++;

	};

	return "index.php?option=com_zoom&Itemid=".$Itemid."&page=view&catid=".$catid."&key=".$keyno."&imgid=".$imgid."&hit=1";
}

function getItemid($option){
	global $database;
	$database->setQuery("SELECT id FROM #__menu WHERE link = 'index.php?option=".mysql_escape_string($option)."'");
	if ($this->_result = $database->query()) {
		$row = mysql_fetch_object($this->_result);
		return $row->id;
	}

}

?>